/* openosfh.c - standard _open_osfhandle() function for Win32 compilers

   Copyright (c) 1995-1999 Rainer Schnitker

   This file is part of RSXNT.

   RSXNT is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   RSXNT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with RSXNT; see the file COPYING.  If not, write to
   the Free Software Foundation, 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA. */

#include <io.h>
#include <fcntl.h>
#include <mscompat.h>

int _open_osfhandle (long osfhandle, int flags)
{
    int f = _imphandle (osfhandle);

    if (f != -1)
    {
        if (flags == O_APPEND)
            fcntl (f, F_SETFL, O_APPEND);

        else if (flags == O_TEXT || flags == O_BINARY)
            setmode (f, flags);
    }
    return f;
}
